// ------------------------------------------------------------------------
// Bunny Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br
//
// $Source:  $
// $Revision:  $
// $Date:  $
//
// $Author:  $
// ------------------------------------------------------------------------

#ifndef _COORD_H_
#define _COORD_H_

//-----------------------------------------------------------
//-----------------------------------------------------------
class cCoord
{
public:
 float x, y, z;

 cCoord(float X = 0, float Y = 0, float Z = 0) : x(X), y(Y), z(Z) {}
 cCoord(const cCoord &coord) { *this = coord; }

 void operator = (const cCoord &coord)
 { x = coord.x; y = coord.y; z = coord.z; }
 void operator = (const float c)
 { x = c; y = c; z = c; }
 void operator += (const cCoord &coord)
 { x += coord.x; y += coord.y; z += coord.z; }
 void operator -= (const cCoord &coord)
 { x -= coord.x; y -= coord.y; z -= coord.z; }
 void operator *= (const float c)
 { x *= c; y *= c; z *= c; }
 void operator /= (const float c)
 { x /= c; y /= c; z /= c; }

 friend cCoord operator + (const cCoord &p1, const cCoord &p2)
 { cCoord p; p.x = p1.x + p2.x; p.y = p1.y + p2.y; p.z = p1.z + p2.z; return p; }
 friend cCoord operator - (const cCoord &p1, const cCoord &p2)
 { cCoord p; p.x = p1.x - p2.x; p.y = p1.y - p2.y; p.z = p1.z - p2.z; return p; }
 friend cCoord operator * (const cCoord &p1, float c)
 { cCoord p; p.x = p1.x * c; p.y = p1.y * c; p.z = p1.z * c; return p; }

};


//-----------------------------------------------------------
//-----------------------------------------------------------
class cRGB
{
public:
 float r, g, b;

 cRGB(float R = 0, float G = 0, float B = 0) : r(R), g(G), b(B) {}
 cRGB(const cRGB &coord) { *this = coord; }

 void operator = (const cRGB &coord)
 { r = coord.r; g = coord.g; b = coord.b; }
 void operator = (const float c)
 { r = c; g = c; b = c; }
 void operator += (const cRGB &coord)
 { r += coord.r; g += coord.g; b += coord.b; }
 void operator += (const float c)
 { r += c; g += c; b += c; }
 void operator -= (const cRGB &coord)
 { r -= coord.r; g -= coord.g; b -= coord.b; }
 void operator *= (const float c)
 { r *= c; g *= c; b *= c; }
 void operator /= (const float c)
 { r /= c; g /= c; b /= c; }

 friend cRGB operator + (const cRGB &p1, const cRGB &p2)
 { cRGB p; p.r = p1.r + p2.r; p.g = p1.g + p2.g; p.b = p1.b + p2.b; return p; }
 friend cRGB operator - (const cRGB &p1, const cRGB &p2)
 { cRGB p; p.r = p1.r - p2.r; p.g = p1.g - p2.g; p.b = p1.b - p2.b; return p; }
 friend cRGB operator * (const cRGB &p1, float c)
 { cRGB p; p.r = p1.r * c; p.g = p1.g * c; p.b = p1.b * c; return p; }

};

#endif
