// ------------------------------------------------------------------------
// Space Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br
//
// $Source:  $
// $Revision:  $
// $Date:  $
//
// $Author:  $
// -------------------------------------------------------------------------
#ifdef _WIN32
#include <windows.h>
#endif

#include <iup.h>
#include <iupgl.h>
#include <iupcontrols.h>

#include "util.h"
#include "cb-main.h"
#include "coord.h"


// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* modeFrame(void)
{
 return Att("spec_mode", IupFrame(
         IupHbox(
          Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
          IupVbox(
           Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
           Att("spec_mode_rd", IupRadio(
            IupVbox(
             Att("mode_emissive_tg", IupToggle("Emissive Spectral Data", "emissive_cb"), "EXPAND", "NO", NULL),
             Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
             Att("mode_reflective_tg", IupToggle("Reflective Spectral Data", "reflective_cb"), "EXPAND", "NO", NULL),
            NULL)),
           NULL),
           Att(NULL, IupFill(), IUP_SIZE, "4", NULL),
           IupHbox(
            Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
            IupVbox(
             Att(NULL, IupLabel("Reference White:"), "EXPAND", "NO", NULL),
             Att("spec_ref_lst", IupList("ref_cb"),
              "DROPDOWN", "YES",
              "VISIBLE_ITEMS", "3",
              "MULTIPLE", "NO",
              "EXPAND", "NO",
              "SIZE", "130x",
             NULL),
            NULL),
            IupFill(),
           NULL),
           Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
          NULL),
          Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
         NULL)),
         "TITLE", "Spectrum Integration",
         "EXPAND", "NO",
        NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* gammaFrame(void)
{
 return Att("spec_gamma", IupFrame(
         IupHbox(
          Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
          IupVbox(
           Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
           Att("gamma_tg", IupToggle("Use Gamma Correction", "gamma_cb"), "EXPAND", "NO", NULL),
           Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
           Att("gamma_val", IupVal(IUP_HORIZONTAL),
            "MIN", "0.1",
            "MAX", "5",
            "VALUE", "2.5",
            "STEP", "0.5",
            "SHOWTICKS", "10",
            "ACTIVE", "YES",
            "TIP", "Gamma = 2.5",
            "EXPAND", "NO",
            "RASTERSIZE", "175x15",
            "MOUSEMOVE_CB", "ValMove_cb",
            "BUTTON_RELEASE_CB", "ValRelease_cb",
           NULL),
           Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
          NULL),
          Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
         NULL)),
         "TITLE", "Gamma",
         "EXPAND", "NO",
        NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* colorsRGB(void)
{
 Ihandle* sRGBCanvas = NULL;
 sRGBCanvas = IupGLCanvas(NULL);
  
 IupSetAttribute(sRGBCanvas, "BUFFER", "DOUBLE");
 IupSetAttribute(sRGBCanvas, "COLOR", "RGBA");
 IupSetAttribute(sRGBCanvas, "RASTERSIZE", "80x60");
 IupSetAttribute(sRGBCanvas, "EXPAND", "NO");
 
 SetsRGBCanvas(sRGBCanvas);

 return Att("spec_srgb",
  IupVbox(
   Att("srgb_tg", IupToggle("sRGB", "srgb_cb"), "EXPAND", "NO"),
   IupHbox(
    IupFill(),
    sRGBCanvas,
    Att(NULL, IupFill(), "SIZE", "5"),
    IupVbox(
     IupFill(),
     IupFrame(Att("srgb_mt", IupMatrix(NULL), 
      "NUMLIN", "3",
      "NUMLIN_VISIBLE", "3",
      "NUMCOL", "4",
      "NUMCOL_VISIBLE", "4",
      "WIDTH1", "20",
      "WIDTH2", "20",
      "WIDTH3", "20",
      "WIDTH4", "20",
      "FGCOLOR*:1", "0.0 0.0 0.0",
      "BGCOLOR*:1", "221 221 221",
      "FGCOLOR*:2", "255 255 255",
      "BGCOLOR*:2", "64 75 100",
      "FGCOLOR*:3", "0.0 0.0 0.0",
      "BGCOLOR*:3", "221 221 221",
      "FGCOLOR*:4", "255 255 255",
      "BGCOLOR*:4", "64 75 100",
      "ALIGNMENT0", "ACENTER",
      "ALIGNMENT1", "ACENTER",
      "SCROLLBAR", "NO",
      "EXPAND", "NO",
      "VALUE_CB", "getsRGB_cb",
      "EDITION_CB", "editsRGB_cb",
     NULL)),
     IupFill(),
    NULL),
    IupFill(),
   NULL),
  NULL),
 NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* colorAdobeRGB(void)
{
 Ihandle* adobeRGBCanvas = NULL;
 adobeRGBCanvas = IupGLCanvas(NULL);
  
 IupSetAttribute(adobeRGBCanvas, "BUFFER", "DOUBLE");
 IupSetAttribute(adobeRGBCanvas, "COLOR", "RGBA");
 IupSetAttribute(adobeRGBCanvas, "RASTERSIZE", "80x60");
 IupSetAttribute(adobeRGBCanvas, "EXPAND", "NO");
 
 SetAdobeRGBCanvas(adobeRGBCanvas);

 return Att("spec_adobe_rgb",
  IupVbox(
   Att("adobe_rgb_tg", IupToggle("Adobe RGB", "adobe_rgb_cb"), "EXPAND", "NO"),
   IupHbox(
    IupFill(),
    adobeRGBCanvas,
    Att(NULL, IupFill(), "SIZE", "5"),
    IupVbox(
     IupFill(),
     IupFrame(Att("adobe_rgb_mt", IupMatrix(NULL), 
      "NUMLIN", "3",
      "NUMLIN_VISIBLE", "3",
      "NUMCOL", "4",
      "NUMCOL_VISIBLE", "4",
      "WIDTH1", "20",
      "WIDTH2", "20",
      "WIDTH3", "20",
      "WIDTH4", "20",
      "FGCOLOR*:1", "0.0 0.0 0.0",
      "BGCOLOR*:1", "221 221 221",
      "FGCOLOR*:2", "255 255 255",
      "BGCOLOR*:2", "64 75 100",
      "FGCOLOR*:3", "0.0 0.0 0.0",
      "BGCOLOR*:3", "221 221 221",
      "FGCOLOR*:4", "255 255 255",
      "BGCOLOR*:4", "64 75 100",
      "ALIGNMENT0", "ACENTER",
      "ALIGNMENT1", "ACENTER",
      "SCROLLBAR", "NO",
      "EXPAND", "NO",
      "VALUE_CB", "getAdobeRGB_cb",
      "EDITION_CB", "editAdobeRGB_cb",
     NULL)),
     IupFill(),
    NULL),
    IupFill(),
   NULL),
  NULL),
 NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* colorAppleRGB(void)
{
 Ihandle* appleRGBCanvas = NULL;
 appleRGBCanvas = IupGLCanvas(NULL);
  
 IupSetAttribute(appleRGBCanvas, "BUFFER", "DOUBLE");
 IupSetAttribute(appleRGBCanvas, "COLOR", "RGBA");
 IupSetAttribute(appleRGBCanvas, "RASTERSIZE", "80x60");
 IupSetAttribute(appleRGBCanvas, "EXPAND", "NO");
 
 SetAppleRGBCanvas(appleRGBCanvas);

 return Att("spec_apple_rgb",
  IupVbox(
   Att("apple_rgb_tg", IupToggle("Apple RGB", "apple_rgb_cb"), "EXPAND", "NO"),
   IupHbox(
    IupFill(),
    appleRGBCanvas,
    Att(NULL, IupFill(), "SIZE", "5"),
    IupVbox(
     IupFill(),
     IupFrame(Att("apple_rgb_mt", IupMatrix(NULL), 
      "NUMLIN", "3",
      "NUMLIN_VISIBLE", "3",
      "NUMCOL", "4",
      "NUMCOL_VISIBLE", "4",
      "WIDTH1", "20",
      "WIDTH2", "20",
      "WIDTH3", "20",
      "WIDTH4", "20",
      "FGCOLOR*:1", "0.0 0.0 0.0",
      "BGCOLOR*:1", "221 221 221",
      "FGCOLOR*:2", "255 255 255",
      "BGCOLOR*:2", "64 75 100",
      "FGCOLOR*:3", "0.0 0.0 0.0",
      "BGCOLOR*:3", "221 221 221",
      "FGCOLOR*:4", "255 255 255",
      "BGCOLOR*:4", "64 75 100",
      "ALIGNMENT0", "ACENTER",
      "ALIGNMENT1", "ACENTER",
      "SCROLLBAR", "NO",
      "EXPAND", "NO",
      "VALUE_CB", "getAppleRGB_cb",
      "EDITION_CB", "editAppleRGB_cb",
     NULL)),
     IupFill(),
    NULL),
    IupFill(),
   NULL),
  NULL),
 NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* positiveErrorColor(void)
{
 Ihandle* posErrorCanvas = NULL;
 posErrorCanvas = IupGLCanvas(NULL);
  
 IupSetAttribute(posErrorCanvas, "BUFFER", "DOUBLE");
 IupSetAttribute(posErrorCanvas, "COLOR", "RGBA");
 IupSetAttribute(posErrorCanvas, "RASTERSIZE", "80x60");
 IupSetAttribute(posErrorCanvas, "EXPAND", "NO");
 
 SetposErrorCanvas(posErrorCanvas);

 return Att("spec_pos_error",
  IupVbox(
   IupFill(),
   IupHbox(
    IupFill(),
    posErrorCanvas,
    IupFill(),
   NULL),
   IupFill(),
  NULL),
 NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* negativeErrorColor(void)
{
 Ihandle* negErrorCanvas = NULL;
 negErrorCanvas = IupGLCanvas(NULL);
  
 IupSetAttribute(negErrorCanvas, "BUFFER", "DOUBLE");
 IupSetAttribute(negErrorCanvas, "COLOR", "RGBA");
 IupSetAttribute(negErrorCanvas, "RASTERSIZE", "80x60");
 IupSetAttribute(negErrorCanvas, "EXPAND", "NO");
 
 SetnegErrorCanvas(negErrorCanvas);

 return Att("spec_neg_error",
  IupVbox(
   IupFill(),
   IupHbox(
    IupFill(),
    negErrorCanvas,
    IupFill(),
   NULL),
   IupFill(),
  NULL),
 NULL);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
Ihandle* InitMainDialog(void)
{
 Ihandle* canvas = NULL;
 canvas = IupGLCanvas(NULL);
  
 IupSetAttribute(canvas, "BUFFER", "DOUBLE");
 IupSetAttribute(canvas, "COLOR", "RGBA");
 IupSetAttribute(canvas, "RASTERSIZE", "500x400");
 
 SetCurrentMainCanvas(canvas);

 Ihandle* dlg = Att("dg_main", IupDialog(
   IupVbox(
    Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
    IupHbox(
     Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
     IupVbox(
      IupHbox(
       Att(NULL, IupFrame(
        IupHbox(
         Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
         IupVbox(
          Att(NULL, IupFill(), IUP_SIZE, "5", NULL),
          modeFrame(),
          Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
          gammaFrame(),
          Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
         NULL),
         Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
        NULL)),
        "TITLE", "Settings",
        "EXPAND", "NO",
       NULL),
      NULL),
      /*Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
      positiveErrorColor(),
      Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
      negativeErrorColor(),*/
     NULL),
     Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
     canvas,
     Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
     IupRadio(
     IupVbox(
      Att(NULL, IupFill(), IUP_SIZE, "3", NULL),
      colorsRGB(),
      Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
      colorAdobeRGB(),
      Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
      colorAppleRGB(),
      Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
      IupHbox(
       IupFill(),
       Att("color_display", IupColorBrowser(), NULL),
       IupFill(),
      NULL),
     NULL)),
     Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
    NULL),
    Att(NULL, IupFill(), IUP_SIZE, "10", NULL),
   NULL)),
  IUP_TITLE, "Spectrum Lab",
  IUP_ICON, "icon_spec",
  IUP_CLOSE_CB, "Exit",
 NULL);

 return dlg;
}

//-------------------------------------------
//-------------------------------------------
void ShowMainDialog(void)
{
 Ihandle* mainDialog = IupGetHandle("dg_main");
 if(!mainDialog)
 {
  mainDialog = InitMainDialog();
  setMainDialogCB();
  IupMap(mainDialog);
 }

 SetDialogToShow();
 IupShowXY(mainDialog, IUP_CENTER, IUP_CENTER);
}

//-------------------------------------------
//-------------------------------------------
int main(int argc, char* argv[])
{
 IupOpen();
 IupGLCanvasOpen();
 IupControlsOpen();

 IupSetLanguage(IUP_ENGLISH);

 SetExecPath((char*)argv[0]);

 string s((char*) argv[0]);
   
 string path = DropFilename(s);
 string ledPath = path + "database\\led\\icon.led";
 IupLoad((char*) ledPath.c_str());

 ShowMainDialog();

 IupMainLoop();
 IupClose();

 return 1;
}
