// ------------------------------------------------------------------------
// Space Project -- Tecgraf/PUC-Rio
// www.tecgraf.puc-rio.br
//
// $Source:  $
// $Revision:  $
// $Date:  $
//
// $Author:  $
// ------------------------------------------------------------------------

#include <iup.h>
#include <iupgauge.h>
#include "util.h"

//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
Ihandle* Att(char* name, Ihandle* elem, char* first, ...)
{
 va_list arg;
 char *att, *val;

 va_start(arg, first);
 att = first;
 while(att)
 {
  val = va_arg(arg, char*);
  IupStoreAttribute(elem, att, val);
  att = va_arg(arg, char*);
 }
 va_end(arg);
 IupSetHandle(name, elem);
 return elem;
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
cCoord CrossProd(const cCoord& u, const cCoord& v)
{
 cCoord w;

 w.x = u.y * v.z - u.z * v.y;
 w.y = u.z * v.x - u.x * v.z;
 w.z = u.x * v.y - u.y * v.x;

 return w;
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
bool FileDialog(string type, string title, string filter, string& name)
{
 Ihandle* h = IupFileDlg();

 IupSetAttribute(h, IUP_DIALOGTYPE, (char*)type.c_str());
 IupSetAttribute(h, IUP_TITLE, (char*)title.c_str());
 IupSetAttribute(h, IUP_EXTFILTER, (char*)filter.c_str());
 IupSetAttribute(h, IUP_NOCHANGEDIR, IUP_YES);
 IupPopup(h, IUP_CENTER, IUP_CENTER);

 if(IupGetInt(h, IUP_STATUS) != -1)
 {
  name = IupGetAttribute(h, IUP_VALUE);
  return true;
 }
 return false;
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void PopupGauge(void)
{
   Ihandle* dg = IupGetHandle("dg_gauge");
   if(!dg)
   {
      dg = Att("dg_gauge", 
         IupDialog(
            IupVbox(
               Att("gauge", IupGauge(),
               IUP_TEXT, "Loading file...",
            NULL),
         NULL)),
         IUP_EXPAND, IUP_NO,
         IUP_TITLE, "Bunny",
         "MINBOX", IUP_NO,
         "MENUBOX", "NO",
         "MAXBOX", IUP_NO,
      NULL);

      IupMap(dg);
   }
   IupShowXY(dg, IUP_CENTER, IUP_CENTER);
}

// ------------------------------------------------------------------------
// ------------------------------------------------------------------------
void KillGauge(void)
{
 Ihandle* h = IupGetHandle("dg_gauge");
 if(h) IupDestroy(h);
}

//-------------------------------------------
//-------------------------------------------
string DropFilename(string s)
{
 string path;

#ifdef _WIN32
 string::size_type i = s.rfind('\\');
#else
 string::size_type i = s.rfind('/');
#endif

 if(i != string::npos) 
  path.assign(s, 0, ++i);

 return path;
}
